version: "3.8"

services:
  execution-servcie-api:
    build:
      context: .
    container_name: picsart-execution-servcie-api
    environment:
      DB_URL: jdbc:mysql://localhost:3306/execution_service
      DB_USERNAME: root
      DB_PASSWORD: example
      KAFKA_BOOTSTRAP_SERVERS: localhost:29092
    depends_on:
      - execution-servcie-db
    ports:
      - 8083:8080

  execution-servcie-db:
    image: mysql
    container_name: picsart-execution-servcie-mysql
    restart: always
    environment:
      MYSQL_ROOT_PASSWORD: example
    ports:
      - 3308:3306
      - 33062:33060

  picsart-execution-servcie-zookeeper:
    image: confluentinc/cp-zookeeper:6.2.0
    restart: always
    environment:
      ZOOKEEPER_SERVER_ID: 1
      ZOOKEEPER_CLIENT_PORT: "2181"
      ZOOKEEPER_TICK_TIME: "2000"
      ZOOKEEPER_SERVERS: "picsart-execution-servcie-zookeeper:22888:23888"
    ports:
      - "2181:2181"

  picsart-execution-servcie-kafka:
    image: confluentinc/cp-enterprise-kafka:6.2.0
    depends_on:
      - picsart-execution-servcie-zookeeper
    ports:
      - "29092:29092"
    environment:
      KAFKA_BROKER_ID: 1
      KAFKA_ZOOKEEPER_CONNECT: 'picsart-execution-servcie-zookeeper:2181'
      KAFKA_LISTENER_SECURITY_PROTOCOL_MAP: PLAINTEXT:PLAINTEXT,PLAINTEXT_HOST:PLAINTEXT
      KAFKA_ADVERTISED_LISTENERS: PLAINTEXT://picsart-execution-servcie-kafka:29092,PLAINTEXT_HOST://localhost:29092
      KAFKA_OFFSETS_TOPIC_REPLICATION_FACTOR: 1
      KAFKA_GROUP_INITIAL_REBALANCE_DELAY_MS: 0
      KAFKA_TRANSACTION_STATE_LOG_MIN_ISR: 1
      KAFKA_TRANSACTION_STATE_LOG_REPLICATION_FACTOR: 1